.sub _onload @LOAD
    .local pmc cl
    cl = subclass "ManagedStruct", "Past"
    addattribute cl, "nci"
    addattribute cl, "yyloc"
.end

.namespace ["Past"]

.sub __init method
    .local pmc nci, f, nul
    nci = new Hash
    setattribute self, "nci", nci
    # load synbol from this executeable i.e. parrot
    # dunno if this works on all platforms
    null nul
    f = dlfunc nul, "imc_open_unit", "pJi"
    nci["open_unit"] = f
    f = dlfunc nul, "IMCC_find_node_nr", "it"
    nci["find_node_nr"] = f
    f = dlfunc nul, "IMCC_new_node", "pJipp"
    nci["new_node"] = f
    f = dlfunc nul, "IMCC_new_const_node", "pJbip"
    nci["new_const_node"] = f
    f = dlfunc nul, "IMCC_dump_nodes", "vJp"
    nci["dump_nodes"] = f
    f = dlfunc nul, "string_pin", "vJS"
    nci["string_pin"] = f

    # new a YYLTYPE struct
    .local pmc str_def, str
    str_def = new .OrderedHash
    .include "datatypes.pasm"
    str_def["first_line"] = .DATATYPE_INT
    push str_def, 0
    push str_def, 0
    str_def["first_column"] = .DATATYPE_INT
    push str_def, 0
    push str_def, 0
    str_def["last_line"] = .DATATYPE_INT
    push str_def, 0
    push str_def, 0
    str_def["last_column"] = .DATATYPE_INT
    push str_def, 0
    push str_def, 0

    new str, .ManagedStruct, str_def
    setattribute self, "yyloc", str
.end

.const int IMC_PCCSUB  	= 0x02

.sub open_unit method
    .local pmc nci, f
    nci = getattribute self, "nci"
    f = nci["open_unit"]
    $P0 = f(IMC_PCCSUB)	  # returns cur_unit
    .return ($P0)
.end

.sub find_node_nr method
    .param string name
    .local pmc nci, f
    .local int nr
    nci = getattribute self, "nci"
    f = nci["find_node_nr"]
    nr = f(name)
    .return (nr)
.end

.sub new_const_node method
    .param string contents
    .param string type
    .param int fl
    .param int fc
    .param int ll
    .param int lc

    .local pmc nci, f, lloc, nod
    .local int typ_nr
    lloc = getattribute self, "yyloc"
    lloc[0] = fl
    lloc[1] = fc
    lloc[2] = ll
    lloc[3] = lc
    nci = getattribute self, "nci"
    # need a malloced string here
    f = nci["string_pin"]
    f(contents)
    f = nci["new_const_node"]
    typ_nr = ord type
    nod = f(contents, typ_nr, lloc)
    .return (nod)
.end

.sub new_node method
    .param int nr
    .param pmc nodes
    .param int fl
    .param int fc
    .param int ll
    .param int lc

    .local pmc nci, f, lloc, nod
    .local int nr
    lloc = getattribute self, "yyloc"
    lloc[0] = fl
    lloc[1] = fc
    lloc[2] = ll
    lloc[3] = lc
    nci = getattribute self, "nci"
    f = nci["new_node"]
    nod = f(nr, nodes, lloc)
    .return (nod)
.end

.sub dump_nodes method
    .param pmc nod
    .local pmc nci, f
    nci = getattribute self, "nci"
    f = nci["dump_nodes"]
    f(nod)
.end

# vim: ft=imc sw=4:

